var target : Transform;
public var enemyTag = "Player";

private var throttle = 0.0;

// The camera doesnt start following the target immediately but waits for a split second to avoid too much waving around.
private var lockCameraTimer = 0.0;

// The current move direction in x-z
private var moveDirection = Vector3.zero;
private var forward = Vector3.zero;
private var right = Vector3.zero;

// The last collision flags returned from controller.Move
private var collisionFlags : CollisionFlags; 

private var isControllable = true;

private var puppet : ShipModel;
private var boid : Steerable;

function Awake ()
{
	moveDirection = transform.TransformDirection(Vector3.forward);
    forward = transform.TransformDirection(Vector3.forward);
	right = Vector3(forward.z, 0, -forward.x);
}

function Start()
{
	puppet = GetComponent(ShipModel);
	boid = GetComponent(Steerable);

    //Screen.showCursor = false;
    //Screen.lockCursor = true;
}


function clamp(value, min, max) {
    if(value < min){ value = min; }
    else if(value > max){ value = max; }
    return value;
}

function think() {
    if(target == null) target = FindNearestTagged(enemyTag);
	// if there are no targets to be had...
	if(target == null) {
	    boid.SetThrottle(0.0);
		return;
	}

    var relative_pos = (target.transform.position - transform.position);
    forward = transform.TransformDirection(Vector3.forward);

    var aim_point = target.transform.position;
	aim_point.z = 0;
	
    puppet.SetAimPos(aim_point);
	
    var dist2targ = relative_pos.sqrMagnitude;
	var weaponRange = 9; // weapon range squared
	
	if( Vector3.Dot(forward, relative_pos) > 0.1) {
        // facing target
        boid.SetThrottle(1.0);
        if( dist2targ < weaponRange ) Fire();
		boid.turnTo2D(aim_point);
    }
    else {
        // facing away from target
        if( dist2targ > weaponRange * 2) {
			boid.SetThrottle(0.5);
			boid.turnTo2D(aim_point);
		}
		else if ( dist2targ < 2 ) {
			boid.SetThrottle(1.0);
			boid.avoid2D(aim_point);
		}
    }

	
}

function FindRandomTagged(tag : String) : Transform {
    var gos : GameObject[];
    gos = GameObject.FindGameObjectsWithTag(tag);
    try { return gos[Random.Range(0, gos.length)].transform; }
    catch (err) { return null; }
}


function FindNearestTagged(tag : String) : Transform {
    var nearest_dist = 999999999999.9;
    var nearest_ship : Transform = null;
    for(var gobj : GameObject in GameObject.FindGameObjectsWithTag(tag)) {
	    var ship = gobj.GetComponent(ShipModel);
        if (ship == null) continue;
        if (ship.team != puppet.team) {
            var this_dist = Vector3.Distance(transform.position, gobj.transform.position);
            if (this_dist < nearest_dist) {
                nearest_dist = this_dist;
                nearest_ship = gobj.transform;
            }
        }
    }

    return nearest_ship;
}


function FixedUpdate() {
    // clamp me to the playfield
    transform.position.z = 0;
    /*
	if (Input.GetButton ("Accelerate"))
	{
        var delta = Input.GetAxis("Accelerate");
        var throttle = boid.GetThrottle();
        if(throttle < 1.0 && delta > 0.0) {
          throttle += Time.fixedDeltaTime * delta;
        }
        else if(throttle > 0.0 && delta < 0.0) {
          throttle += Time.fixedDeltaTime * delta;
        }
        puppet.SetThrottle(throttle);
	}*/

    //cam_ray = cam.ScreenPointToRay (Vector3(Input.mousePosition.x,Input.mousePosition.y,0));
    //puppet.Turn(Vector3 (0, turnx, 0));
    think();
}


function Fire() {
    //var aim_point = puppet.GetAim().GetPoint(1000.0);
    //var aim_point = cam_ray.GetPoint(1000.0);
	var aim_point = Vector3.zero;
    BroadcastMessage("Pewpew", aim_point, SendMessageOptions.DontRequireReceiver);
}


function Update() {
    forward = transform.TransformDirection(Vector3.forward);
    //Fire();
    
   
    //FixedUpdate();
}

function OnControllerColliderHit (hit : ControllerColliderHit )
{
//	Debug.DrawRay(hit.point, hit.normal);
	if (hit.moveDirection.y > 0.01) 
		return;
	wallJumpContactNormal = hit.normal;
}

function GetThrottle() {
    return throttle;
}

function GetDirection () {
	return moveDirection;
}


function GetLockCameraTimer () 
{
	return lockCameraTimer;
}


@script RequireComponent(ShipModel)
@script AddComponentMenu("Oolong/Ship (AI Controller 2D)")
