@script ExecuteInEditMode ()
var blockTexture : Texture2D;
var spacing = 1;
var verticalOrientation = false;

private var maxBlocks : int = 10;
private var blockCount : int = 10;

private var posX : float;
private var posY : float;

function Start()
{
	posX = transform.position.x * Screen.width;
	posY = transform.position.y * Screen.height;
}
function OnGUI()
{
    var scale = transform.localScale;
	var i : int;
	if(!verticalOrientation) {
		GUI.BeginGroup(Rect(posX,
									 Screen.height - posY,
									 (blockTexture.width * maxBlocks * scale.x) + (spacing * maxBlocks),
									 blockTexture.height * scale.y));
			for(i = 0; i < blockCount ; i++) {
				var originx = i * blockTexture.width * scale.x + (spacing * scale.x);
				GUI.DrawTexture(Rect(originx,0,blockTexture.width * scale.x, blockTexture.height * scale.y), blockTexture);
			}
		GUI.EndGroup();
	}
	else {
		GUI.BeginGroup(Rect(posX,
									 Screen.height - posY,
									 blockTexture.width * scale.x,
									 (blockTexture.height * maxBlocks * scale.y) + (spacing * maxBlocks)));
			for(i = 0; i < blockCount ; i++) {
				var originy = i * blockTexture.height * scale.y + (spacing * scale.y);
				GUI.DrawTexture(Rect(0,originy,blockTexture.width * scale.x, blockTexture.height * scale.y), blockTexture);
			}
		GUI.EndGroup();

	}
}

function Update() {
	//UpdateBlocks(Random.Range(1,20));
}

function SetBlocks(input : int)
{
	blockCount = input;
}