public var team : String;
var damage = 2.0;
var impact_sound : AudioClip;

public var explosionType : GameObject;

public var passesThroughEnemies = false;

private var master : Transform;
private var bulletLife : float;

function Start() {
	if(bulletLife > -1) {
		yield WaitForSeconds(bulletLife);
		Kill();
	}
}

function OnTriggerEnter(collider : Collider) {
	// bullets shouldn't collide with other bullets
	// FIXME: might change this later for anti-missile missiles or other such things
    if(collider.GetComponent(Bullet) != null) return;
    if(collider.GetComponent(Influence) != null) return;
    
	//var sound = GetComponent(AudioSource);
    //sound.play();
	
	//var othership = collider.GetComponent(ShipModel);
	//if(othership != null && othership.team != team)
	if(explosionType != null)
		boom = Instantiate(explosionType, transform.position, transform.rotation);
		
	if(!passesThroughEnemies) {
	    //audio.PlayOneShot(impact_sound);
		Kill();
	}
}

function Kill() {
	StopAllCoroutines();
    var trails = transform.GetComponentsInChildren(TrailRenderer); 
    for(var trail : TrailRenderer in trails) {
        trail.transform.parent=null;
        trail.autodestruct = true;
    }
	Destroy(gameObject);
}

function SetMaster(value : Transform) {
    master = value;
}

function SetLife(value : float) {
	bulletLife = value;
}

@script AddComponentMenu("Oolong/Bullet")

