public var player : Transform;
public var playerShipType : GameObject;
public var shipTypes : GameObject[];
public var spawnPoint : SpawnPoint;
public var gameFrame : Transform;
public var cursor_pic : Transform;
public var scoreKeepingText : GUIText;


private var spawning = false;
private var playerIsDead = true;
private var playerDeaths = 0;

function Update() {
	if(player == null && !playerIsDead) Playerdeath();
    if(player == null && playerIsDead && playerShipType != null && Input.GetButtonDown("Fire1") && !spawning) Respawn_player();
	
	scoreKeepingText.text = "deaths: "+ playerDeaths;
}

function convertAItoPlayer(ship : GameObject) {
    var ai = ship.GetComponent(AIShipController_2D);
    if(ai != null) Destroy(ai);
    var controller = ship.AddComponent(MouseShipController_2D);
    controller.frame = gameFrame;
    controller.cameraObject = gameFrame.Find("Main Camera").camera;
	controller.cursor_pic = cursor_pic;
	ship.GetComponent(Steerable).SetThrottle(1.0);
    return ship;
}

function Playerdeath() {
	playerDeaths += 1;
	playerIsDead = true;
}

function Respawn_player() {
    spawning = true;
	
	if(spawnPoint == null) spawnPoint = FindBestSpawn();
	
    //yield WaitForSeconds(3.0);
    clone = Instantiate(playerShipType, spawnPoint.transform.position, spawnPoint.transform.rotation);
    convertAItoPlayer(clone);
	player = clone.transform;
	GetComponent(Telemetry).target = clone.GetComponent(ShipModel);
	spawning = false;
	playerIsDead = false;
}

function FindBestSpawn() {
	var furthest : SpawnPoint;
	var furthest_y = 99999999999999999.9;

	var carriers = FindObjectsOfType(CapShipModel);
	for(var carrier : CapShipModel in carriers) {
		var spawn = carrier.GetComponentInChildren(SpawnPoint);
		if(spawn != null && carrier.transform.position.y > furthest_y) {
			furthest = spawn;
			furthest_y = carrier.transform.position.y;
		}
	}
	
	return furthest;
}

function OnGUI () {
    if(playerShipType == null || Input.GetButton("Choose Ship Type")) {
		// Make a background box
		GUI.Box (Rect ((Screen.width/2)-120, (Screen.height/2)-40,240,120), "Choose your ship");

		for(var i=0; i<shipTypes.length ; i++) {
			if (GUI.Button (Rect ((Screen.width/2)-120,(Screen.height/2)+(40*i),240,40), shipTypes[i].name)) {
				playerShipType = shipTypes[i];
			}
		}
    }

}

function GetPlayerDeaths() {
	return playerDeaths;
}