
var deadzone = 0.15;

var target : Transform;
var reticle : Transform;
var cursor_pic : Transform;

public var cameraObject : Camera;
public var camera_pan = 0.003;

private var throttle = 0.0;
private var cam_ray = Ray(Vector3.zero, Vector3.forward);

// The camera doesnt start following the target immediately but waits for a split second to avoid too much waving around.
private var lockCameraTimer = 0.0;

// The current move direction in x-z
private var moveDirection = Vector3.zero;
private var forward = Vector3.zero;
private var right = Vector3.zero;
// The current vertical speed
private var verticalSpeed = 0.0;
// The current x-z move speed
private var moveSpeed = 0.0;

// The last collision flags returned from controller.Move
private var collisionFlags : CollisionFlags; 

private var isControllable = true;

private var aim_point : Vector3;

private var puppet : ShipModel;
private var boid : Steerable;

public var frame : Transform;

function Awake ()
{
	moveDirection = transform.TransformDirection(Vector3.forward);
    forward = transform.TransformDirection(Vector3.forward);
	right = Vector3(forward.z, 0, -forward.x);
    
    //cameraObject = FindObjectOfType(Camera);
}

function Start()
{
	puppet = GetComponent(ShipModel);
	boid = GetComponent(Steerable);

    //frame = transform.root.Find("GameFrame");

    //Screen.showCursor = false;
    //Screen.lockCursor = true;
}

// This next function responds to the "HidePlayer" message by hiding the player. 
// The message is also 'replied to' by identically-named functions in the collision-handling scripts.
// - Used by the LevelStatus script when the level completed animation is triggered.

function HidePlayer()
{
	GameObject.Find("rootJoint").GetComponent(SkinnedMeshRenderer).enabled = false; // stop rendering the player.
	isControllable = false;	// disable player controls.
}

// This is a complementary function to the above. We don't use it in the tutorial, but it's included for
// the sake of completeness. (I like orthogonal APIs; so sue me!)

function ShowPlayer()
{
	GameObject.Find("rootJoint").GetComponent(SkinnedMeshRenderer).enabled = true; // start rendering the player again.
	isControllable = true;	// allow player to control the character again.
}


function clamp(value, min, max) {
    if(value < min){ value = min; }
    else if(value > max){ value = max; }
    return value;
}

function FixedUpdate() {
    // clamp me to the playfield
    transform.position.z = 0;

	if (Input.GetButton ("Accelerate"))
	{
        var delta = Input.GetAxis("Accelerate");
        var throttle = boid.GetThrottle();
        if(throttle < 1.0 && delta > 0.0) {
          throttle += Time.fixedDeltaTime * delta;
        }
        else if(throttle > 0.0 && delta < 0.0) {
          throttle += Time.fixedDeltaTime * delta;
        }
        boid.SetThrottle(throttle);
	}

	if (!Input.GetButton("Shields")) {
	    puppet.ShieldsDown();
	}

	// can't shoot while afterburner is on
	if(Input.GetButton("Afterburner"))
	{
		boid.Thrust(1.0);
	}
	else if (Input.GetButton("Shields")) {
	    puppet.Shields();
	}
	else if (Input.GetButton("Fire1")) {
        Fire();
    }
	

    var cursor = Vector3(0,0,0);
    cursor.x = (Input.mousePosition.x - Screen.width/2) / (Screen.width/2);
    cursor.y = (Input.mousePosition.y - Screen.height/2) / (Screen.height/2);

    puppet.SetCursor(cursor);

    var turnx = 0.0;
    var turny = 0.0;


    //cam_ray = cam.ScreenPointToRay (Vector3(Input.mousePosition.x,Input.mousePosition.y,0));
    aim_point = cameraObject.ScreenToWorldPoint (Vector3 (Input.mousePosition.x,Input.mousePosition.y,cameraObject.nearClipPlane));
	aim_point.z = 0;

    puppet.SetAimPos(aim_point);

    // FIXME : just set this to weapon range sometime...
    //var aim_point = cam_ray.GetPoint(1000.0);
    //puppet.SetAim(new Ray(transform.position, aim_point));
    //puppet.SetAim(cam_ray);
    
    //var turn_direction = Vector3 (Input.GetAxis("Vertical"), Input.GetAxis("Vertical"), Input.GetAxis("Roll"));
	if( Input.GetButton("Hold Course") ) {
		camera_pan = 0.006;
	}
	else {
        camera_pan = 0.003;
        boid.turnTo2D(aim_point);
	}
	//puppet.Turn(Vector3 (0, turnx, 0));

	moveCamera();
}


function moveCamera() {
    //cam.transform.position.x = transform.position.x;
    //cam.transform.position.y = transform.position.y;
	var cursor_screen = new Vector2(Mathf.Clamp(Input.mousePosition.x, 0, Screen.width),
		Mathf.Clamp(Input.mousePosition.y, 0, Screen.height));
	
	//update camera position to give max visibility
	var max_view_distance = 100;
	//#_.cursor_world = (_.cursor_world[0] + puppet.sprite.x + max_view_distance)
	var x_diff = cursor_screen.x - (Screen.width / 2);
	var y_diff = cursor_screen.y - (Screen.height / 2);
	// FIXME : panning is very jittery right now...
	// tell the camera to slowly pan to our destination
	var camera_destination = new Vector2(x_diff * camera_pan, y_diff * camera_pan);
	//cam.transform.position.x = camera_destination.x + puppet.transform.position.x;
	//cam.transform.position.y = camera_destination.y + puppet.transform.position.y;
	frame.position.x = camera_destination.x + transform.position.x;
	frame.position.y = camera_destination.y + transform.position.y;

}

function Fire() {
    //var aim_point = puppet.GetAim().GetPoint(1000.0);
    //var aim_point = cam_ray.GetPoint(1000.0);
    BroadcastMessage("Pewpew", Vector3.zero, SendMessageOptions.DontRequireReceiver);
}


function Update() {
    forward = transform.TransformDirection(Vector3.forward);
	
	if (!isControllable)
	{
		// kill all inputs if not controllable.
		Input.ResetInputAxes();
	}

    cursor_pic.position.x = Input.mousePosition.x / Screen.width;
    cursor_pic.position.y = Input.mousePosition.y / Screen.height;

    /*
	// Calculate actual motion
	var movement = moveDirection * moveSpeed + Vector3 (0, verticalSpeed, 0) + inAirVelocity;
	movement *= Time.deltaTime;
	
	// Move the controller
	var controller : CharacterController = GetComponent(CharacterController);
	collisionFlags = controller.Move(movement);
	
	transform.rotation = Quaternion.LookRotation(moveDirection);
    */
    //var reticle_pos = cam.WorldToScreenPoint(target.position);
    //reticle.transform.position.x = reticle_pos.x / Screen.width;
    //reticle.transform.position.y = reticle_pos.y / Screen.height;

    //FixedUpdate();
}

function GetAim() {
    return aim_point;
}

function GetSpeed () {
	return moveSpeed;
}

function GetThrottle() {
    return throttle;
}

function GetDirection () {
	return moveDirection;
}


function GetLockCameraTimer () 
{
	return lockCameraTimer;
}

function IsMoving ()  : boolean
{
	return Mathf.Abs(Input.GetAxisRaw("Vertical")) + Mathf.Abs(Input.GetAxisRaw("Horizontal")) > 0.5;
}


@script RequireComponent(ShipModel)
@script AddComponentMenu("Oolong/Ship (Controller -- Mouse 2D)")
