// radar! by PsychicParrot, adapted from a Blitz3d script found in the public domain online somewhere ..
//

public var friendlyBlip : Texture;
public var enemyBlip : Texture;
public var blipSize : int = 4;
public var radarBG : Texture;

public var centerObject : Transform;
public var friendlyPlanet : Transform;
public var enemyPlanet : Transform;
public var mapScale = 0.3;
private var mapCenter : Vector2;

public var size : int = 128;
private var sizehalf : int = size / 2;

function Start () {
    mapCenter = new Vector2(transform.position.x * Screen.width, Screen.height - (transform.position.y * Screen.height));

}

function OnGUI () {
    //  GUI.matrix = Matrix4x4.TRS (Vector3.zero, Quaternion.identity, Vector3(Screen.width / 600.0, Screen.height / 450.0, 1));
	/*GUI.DrawTexture(Rect(mapCenter.x-sizehalf,mapCenter.y-sizehalf,size,size),radarBG);*/
	drawBlip(enemyPlanet,enemyBlip);
	drawBlip(friendlyPlanet,friendlyBlip);
		
	// Draw blips for zombies
	DrawBlipsForTagged("Enemy");
	DrawBlipsForTagged("Player");
}

function DrawBlipsForCows(){
    
     // Find all game objects with tag Cow
    var gos : GameObject[];
    gos = GameObject.FindGameObjectsWithTag("Cow"); 

    var distance = Mathf.Infinity; 
    var position = transform.position; 

    // Iterate through them
    for (var go : GameObject in gos)  { 

        drawBlip(go,enemyBlip);

    }
 
}

function drawBlip(obj,aTexture){
    //var debug = GameObject.Find("Debug Text").GetComponent(GUIText);

	if(centerObject != null) centerPos=centerObject.position;
	else centerPos = Vector3.zero;
	
    extPos=obj.position;
    
    // first we need to get the distance of the enemy from the player
    //dist=Vector3.Distance(centerPos,extPos);

    //var screen_relation = centerCamera.WorldToScreenPoint(extPos);
    bX = extPos.x * mapScale;
    bY = extPos.y * -mapScale;

   
    // this is the diameter of our largest radar circle
    GUI.DrawTexture(Rect(mapCenter.x+bX,mapCenter.y+bY,blipSize, blipSize),aTexture);
}

function DrawBlipsForTagged(tag : String){
    
    // Find all game objects tagged Enemy
    var gos : GameObject[];
    gos = GameObject.FindGameObjectsWithTag(tag);

    //var distance = Mathf.Infinity; 
    var position = transform.position; 
	
    // Iterate through them and call drawBlip function
    for (var go : GameObject in gos)  {
        if(go.transform == centerObject){ continue; } 
        var othership = go.GetComponent(ShipModel);
		if(othership == null){ continue; }
        //var thisship = centerObject.GetComponent(ShipModel);
        if(othership.team == "kreuzzug") {
            drawBlip(go.transform,friendlyBlip);
        }
        else {
            drawBlip(go.transform,enemyBlip);
        }
    }
 
}

