var projectile : GameObject;

var rateOfFire : float = 0.15;
var bulletLife = 1.0;
var speed = 10.0;
var damage = 1.0;

var firing_arc = 0.2;

private var my_aim : Vector3;
private var original_forward : Vector3;
private var bulletRange;

private var cooldown : float = 0.0;
private var myaudio : AudioSource;

function Awake() {
    bulletRange = speed * bulletLife;
}

function Start() {
    original_forward = transform.TransformDirection(Vector3.forward);
    myaudio = gameObject.GetComponent(AudioSource);
}

function Update() {
    if (cooldown > 0) {
        cooldown -= Time.deltaTime;
        if (cooldown < 0) { cooldown = 0; }
    }
}


function isInsideArc(aim_point : Vector3) {
    forward = transform.parent.TransformDirection(Vector3.forward);
    var angleto = Vector3.Angle(forward, aim_point);
    if (angleto <= firing_arc) { return true; }
    else { return false; }
}

/*
function Aim(aim_point : Vector3) {
    var difference = aim_point - transform.parent.position;
    forward = transform.TransformDirection(Vector3.forward);
    aim_dot = Vector3.Dot(forward, difference.Normalize());


    if( aim_dot < 1.0 - firing_arc) {
        // clamp to the edge of the firing arc
        var coplane = new Plane(forward, aim_point, Vector3.zero);
        var axis = coplane.normal;
        // take the forward vector, and rotate it on this axis
        // so it is at the edge of the firing arc.
        
    }
}
*/

/*
(5:04:37 PM) so0os: so.... you have two points in  space
(5:04:51 PM) so0os: shooter and the shotee
(5:05:04 PM) so0os: or whatever you're aiming at, just calc the distance
(5:06:07 PM) so0os: dist=sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2)+(y1-y2)*(y1-y2); then divide difference by the distance and you have your normaluised vector, just multiply it by the arc
(5:06:50 PM) luvcraft: you also probably have a normalize function in that library.
(5:06:58 PM) so0os: vx=((x1-x2)/dist)*arc; vy=((y1-y2)/dist)*arc; vz=((z1-z2)/dist)*arc;
(5:07:11 PM) so0os: use it, it will be faster for sure
 */


function Aim(aim_point : Vector3) {
    // make sure this uses the parent ship's forward
    forward = transform.parent.TransformDirection(Vector3.forward);

    transform.LookAt(Vector3.RotateTowards(forward, aim_point, firing_arc * Mathf.Deg2Rad, 1000.0));
}

function Pewpew(aim_point : Vector3) {
    if (cooldown <= 0){
        if(firing_arc > 0) Aim(aim_point);
        FireBullet();
        myaudio.Play();
        cooldown = rateOfFire;
        return true;
    }
    return false;
}

function FireBullet() {
    // Instantiate the projectile at the position and rotation of this transform
    var clone : GameObject;
    var ship : Transform = transform.parent;
	var parent_ship : ShipModel = transform.root.GetComponent(ShipModel);

    //transform.LookAt(aim_point);

    clone = Instantiate(projectile, transform.position, transform.rotation);
	clonebullet = clone.GetComponent(Bullet);
	if(clonebullet != null) {
		clonebullet.SetLife(bulletLife);
		clonebullet.damage = damage;
		clonebullet.team = parent_ship.team;
	}

    var missileController = clone.GetComponent(MissileController);
    if( missileController != null) missileController.SetMaster(ship);

    var clonebody = clone.GetComponent(Rigidbody);

    // Give the cloned object an initial velocity along the current
    // object's Z axis
    clonebody.velocity = parent_ship.rigidbody.velocity + transform.TransformDirection (Vector3.forward * speed);
    //clone.velocity = transform.TransformDirection (Vector3.forward * speed);

    Physics.IgnoreCollision(clone.collider, parent_ship.collider);
    //Destroy(clone, bulletLife);
}

@script RequireComponent(ShipModel)
@script AddComponentMenu("Oolong/Weapon")
